



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ChildNodes详解及其兼容性处理方式</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ChildNodes详解及其兼容性处理方式</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-22 15:26:50 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>写在前面：在做insertBefore插入节点练习时发现一个问题，插入childNodes[0]和childNodes[1]时插入的位置是一样的！于是有了childNodes的了解，有了这篇文章，欢迎交流，欢迎拍砖。</p>
<p>本文包括如下:</p>
<p>1、DOM 常用节点类型说明</p>
<p>2、childNodes.Length详解</p>
<p>3、节点中取值问题</p>
<p>4、childNodes兼容性处理</p>
<p>说明：本文综合网上其它博文对于childNodes的详解。</p>
<h3>1、DOM 常用节点类型说明：</h3>
<table>
<tbody>
<tr>
<th>NodeType</th>
<th>　　NodeName</th>
<th>&nbsp;</th>
</tr>
<tr>
<td>1</td>
<td>ELEMENT_NODE</td>
<td>元素节点</td>
</tr>
<tr>
<td>2</td>
<td>ATTRIBUTE_NODE</td>
<td>属性节点</td>
</tr>
<tr>
<td>3</td>
<td>TEXT_NODE</td>
<td>文本节点</td>
</tr>
<tr>
<td>4</td>
<td>COMMENT_NODE</td>
<td>注释节点</td>
</tr>
<tr>
<td>5</td>
<td>DOCUMENT_NODE</td>
<td>文档节点</td>
</tr>
</tbody>
</table>
<p>对于元素节点、属性节点、文本节点的理解<a href="http://www.cnblogs.com/dh616854836/archive/2011/08/14/2138038.html" rel="external nofollow noreferrer">请戳这里</a></p>
<h3>2、childNodes.Length详解</h3>
<p>我们都知道js操作document时，使用childNodes取得节点的子节点个数时，在<strong>IE6、7、8</strong>下时完全没有问题的，但是在其它浏览器下使用childNodes获取节点，它会将空格符、回车符、换行符也看做一个文本节点，使得节点长度不是我们想要的，我们看一下如下示例：</p>
<p>代码部分：</p>
<div>
<pre class="prettyprint linenums">    &lt;div id="div1"&gt;<br />
        &lt;p id="fg"&gt;1&lt;/p&gt;<br />
        &lt;p&gt;2&lt;/p&gt;<br />
    &lt;/div&gt;

js<br />
var c=document.getElementById("div1");<br />
            alert(c.childNodes.length);<br />
            alert(c.childNodes[0].nodeName);<br />
            alert(c.childNodes[1].nodeName);<br />
            alert(c.childNodes[2].nodeName);<br />
            alert(c.childNodes[3].nodeName);<br />
            alert(c.childNodes[4].nodeName);<br />
            alert(c.childNodes[5].nodeName);</pre>
</div>
<p>获取到的childNodes长度及其nodeName如下图所示，通过下图我们可以了解到换行符被看成文本节点，如果是在IE6,7,8中则为（2、p、p）;</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/742004/201507/070901417838857.jpg" /></p>
<p>如果我们把HTML代码改成如下，则结果为：</p>
<div>
<pre class="prettyprint linenums">&lt;div id="div1"&gt;&lt;p id="fg"&gt;1&lt;/p&gt;&lt;p&gt;2&lt;/p&gt;&lt;/div&gt;</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/742004/201507/070907557527708.jpg" /></p>
<p>所以就如我们前面所说在浏览器中childNodes连一个回车符都不放过！</p>
<h3>3、节点中取值问题</h3>
<div>
<pre class="prettyprint linenums">    &lt;div id="div1"&gt;<br />
        &lt;p id="fg"&gt;1&lt;/p&gt;<br />
        &lt;p&gt;2&lt;/p&gt;<br />
    &lt;/div&gt;</pre>
</div>
<p>我们把上个小节中代码nodeName换成NodeValue，看一下结果如图</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/742004/201507/070918412523571.jpg" /></p>
<p>不科学啊！为什么&lt;p&gt;的nodeValue值会为空！</p>
<p>原因在于&lt;p&gt;1&lt;/p&gt;，<strong>元素节点 &lt;p&gt;，拥有一个值为 "1" 的文本节点。1并不是元素节点p的值</strong></p>
<p>那么我们若想取到&lt;p&gt;中的数字1怎么办，我们需要获得的是&lt;p&gt;的childNodes的nodeValue值</p>
<div>
<pre class="prettyprint linenums">var divNodes=document.getElementById("div1").getElementsByTagName("p");<br /> alert(divNodes[0].childNodes[0].nodeValue);

或者<br />
var pp=document.getElementById("fg");<br />
alert(fg.childNodes[0].nodeValue);</pre>
</div>
<h3>4、childNodes兼容性处理</h3>
<p>我们可以通过判断div子节点的个数是否等于子节点元素节点的个数，若等于，继续操作，若不等于，可通过新建一个数组，找出div子节点的元素节点填入数组，然后对数组进行操作，我们以insertBefore（）插入节点为例，代码如下：</p>
<div>
<pre class="prettyprint linenums">&lt;!DOCTYPE html&gt;<br />
&lt;html&gt;<br />
&lt;head&gt;<br />
    &lt;meta charset="utf-8"&gt;<br />
    &lt;meta http-equiv="X-UA-Compatible" content="IE=edge"&gt;<br />
    &lt;title&gt;&lt;/title&gt;<br />
    &lt;link rel="stylesheet" href=""&gt;<br />
&lt;/head&gt;<br />
&lt;body&gt;<br />
    &lt;div id="div1"&gt;<br />
        &lt;p id="fg"&gt;1&lt;/p&gt;<br />
        &lt;p&gt;2&lt;/p&gt;<br />
    &lt;/div&gt;

&lt;button onclick="test()"&gt;插入节点&lt;/button&gt;<br />
    &lt;script&gt;<br />
        function test()<br />
        {<br />
            var a=document.createElement("p");<br />
            var textNodes=document.createTextNode("我是将要插入的节点");<br />
            a.appendChild(textNodes);<br />
            var c=document.getElementById("div1");<br />
            var divNodes=document.getElementById("div1").getElementsByTagName("p");//计算子节点&lt;p&gt;的个数<br />
            if(c.childNodes.length!=divNodes.length)<br />
            {<br />
                var rows=[];<br />
                for(var i=0;i&lt;c.childNodes.length;i++)<br />
                {<br />
                    if(c.childNodes[i].nodeType==1)//类型为1表示为元素节点<br />
                    {<br />
                        rows.push(c.childNodes[i]);//填入数组<br />
                    }<br />
                }<br />
                c.insertBefore(a,rows[0]);<br />
            }<br />
            else{<br />
            c.insertBefore(a,c.childNodes[0]);//适用于IE6、7、8<br />
            }<br />
}&lt;/script&gt;<br />
&lt;/body&gt;<br />
&lt;/html&gt;</pre>
</div>
<p>这样插入时childNodes[0]和childNodes[1]插入的位置就不一样啦。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pjgxy9.html">CentOS 7&period;0系统安装配置步骤详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mvd668.html">plt和got</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdnrgx9.html">关于delete 和 new</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdeeo109.html">strcpy&comma; memcpy&comma; memset函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdn5gk9.html">Dreamer2&period;1 发布 新增将Bean解析成xml和json</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkw3re8.html">linux指令（目录类操作指令）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdn1479.html">java class生成jar包&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljl6wx9.html">一个吊丝android个人开发者的逆袭之路</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k44nz9.html">USB的四种传输类型与端点</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zol5r1q.html">MySQL innodb&lowbar;table&lowbar;monitor 解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpnzwzq.html">网络编程第六讲Select模型</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyw0l2q.html">antd按需加载&comma;配置babel-plugin-import插件&comma;编译后报错&period;bezierEasingMixin&lpar;&rpar;解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zykze19.html">yaml的简单学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/q256kgvq.html">Struts2学习（一）&mdash;&mdash;&mdash;&mdash;Struts2入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd4jg09.html">洗礼灵魂，修炼python（54）--爬虫篇&mdash;urllib2模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w1mrrq.html">drf频率组件</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r6gen9.html">jquery给按钮绑定事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7e5klg9.html">JAVA字符编码测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7e5k5k9.html">RichTextBox控件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pr5jjq.html">ansible报错AttributeError&colon; module &amp;&num;39&semi;urllib&period;request&amp;&num;39&semi; has no attribute &amp;&num;39&semi;HTTPSHandler&amp;&num;39&semi;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pj0o7k9.html">qt界面不显示的原因</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yrvv5q.html">C&plus;&plus;程序设计实践指导1&period;8求指定范围内的所有素数改写要求实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdenygj9.html">outlook 2007   IMAP设置和配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1ye739.html">SharedPreferences基础</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1yex39.html">记微信开发&lpar;自定义回复&amp;amp&semi;关注回复&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1y7m59.html">IE6、7 a链接内图片加滤镜后导致a标签链接失效问题解决</a>
			</li>
						<li><a href="https://www.batexi.com/a/96oxeey9.html">php 函数之 &rpar;&lowbar;each&lpar;&rpar;list&lpar;&rpar;implode&lpar;&rpar;explode&lpar;&rpar;in&lowbar;array&lpar;&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0w3k4q.html">【ecos学习3】redboot on vmware 网络配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vzzno8.html">MYSQL 加密的 3 类方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2worzvq.html">SSD和HDD的区别</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
